<id>
Split Splice Advanced
</id>

<version>
beta 4
</version>

<mod info>
Split Splice Advanced is an updated version of the Split Splice Copy mod (YaBB 3.1) entirley re-written for use on YaBB2.1 boards.  The mod idea is based off of the original Split / Splice mod by BHRA Webmaster, but has since been advanced to include copy functions and specific post placement with a thread.

The mod allows an Admin, Gmod, or moderator to split and splice posts together or copy posts across categories and boards that they have access to and place them anywhere within a thread.  They may choose to leave a message saying the posts were moved, leave the originals (copy function), or leave nothing.  They may also choose to create a new thread with selected posts.


Installation 
--------------------
1.  Mod the file Display.pl, SubList.pl, and ModList.pl
2.  Upload in ASCII to correct directory.
3.  Replace SplitSplice.pl with the version included in the zip file.
4.  Upload Split_Splice_Adv.lng to the correct language folder (English, until new translations come about)
5.  Upload the Split_Splice_Adv folder to the ModImages folder.

Version History
---------------
ver1 - Original release.
ver2 - Updated for multiple languages.
ver3 - Removed some hard coding of text.
ver4 - Fixed an error that did not allow for accurate update of the old thread ctb.

Comments
----------------
- I have chosen not to replace the Split and Splice functions with Split Splice Advanced, but to supplement, although there is some overlap in function.
</mod info>

<author>
astro-pilot
</author>

<homepage>

</homepage>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		$template_splice = qq~$menusep<a href="$scripturl?board=$currentboard;action=splice;thread=$viewnum">$img{'admin_splice'}</a>~;
</search for>

<replace>
		$template_splice = qq~$menusep<a href="$scripturl?board=$currentboard;action=splice;thread=$viewnum">$img{'admin_splice'}</a>$menusep<a href="$scripturl?cat=$curcat;board=$currentboard;action=split_splice_adv;thread=$viewnum"><img src="$modimgurl/Split_Splice_Adv/split_splice_button_$language.$imgext" border="0" /></a>~; ## Split Splice Advanced mod ##
</replace>

<edit file>
Sources/SubList.pl
</edit file>

<search for>
'split',"SplitSplice.pl&Split",
'split2',"SplitSplice.pl&Split2",
</search for>

<add after>
'split_splice_adv',"SplitSplice.pl&Split_Splice_Adv", ## Split Splice Advanced mod ##
'split_splice_adv2',"SplitSplice.pl&Split_Splice_Adv2", ## Split Splice Advanced mod ##
</add after>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$split_splice_adv = "Split Splice Advanced|astro-pilot|Allows a moderator to split and splice posts together or copy posts across categories and boards and place them anywhere within a thread|beta 4|03/13/06";
	push (@installed_mods, "$split_splice_adv");
</add before>