###############################################################################
# SplitSplice.pl                                                              #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.1                                                    #
# Released:       November 8, 2005                                            #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2005 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
#               Your source for web hosting, web design, and domains.         #
###############################################################################

$splitspliceplver = 'YaBB 2.1 $Revision: 1.2 $';
if ($action eq 'detailedversion') { return 1; }

LoadLanguage("SplitSplice");

sub Split {
	if (!$iammod && !$iamadmin && !$iamgmod) { &fatal_error("$sstxt{'2'}"); }
	$curthread = $INFO{'thread'};
	&LoadCensorList;

	$postlist = "";
	fopen(FILE, "$datadir/$curthread.txt");
	@messages = <FILE>;
	fclose(FILE);
	$counter = 0;
	for ($counter = 1; $counter <= $#messages; $counter++) {
		chomp $messages[$counter];
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb) = split(/[\|]/, $messages[$counter]);
		$msub = &Censor($msub);
		if (length($msub) > 25) { $msub = substr($msub, 0, 25) . qq~ ...~; }
		$postlist .= qq~<option value="$counter">$counter: $msub</option>\n~;
	}

	$yymain .= qq~
<table border="0" width="80%" cellspacing="0" cellpadding="0" class="bordercolor" align="center">
  <tr>
    <td>
      <table cellpadding="4" cellspacing="1" border="0" width="100%">
        <tr>
          <td colspan="2" class="titlebg"><img src="$imagesdir/admin_split.gif" align="absmiddle" /> <font size="2" class="text1"><b>$sstxt{'1'}</b></font></td>
        </tr><tr>
          <td colspan="2" class="windowbg" align="center"><font size="2">
            <script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
            <form action="$scripturl?action=split2;thread=$INFO{'thread'}" method="POST" name="split" onSubmit="return submitproc()"><br />
            <b>$sstxt{'3'}:</b> <select name="postid">
		$postlist
            </select>
            <input type="submit" value="$sstxt{'1'}" />
            </form>
          </font></td>
        </tr>
	<tr>
          <td colspan="2" class="windowbg"><font size="1">$sstxt{'4'}</font></td>
        </tr>
      </table>
    </td>
  </tr>
</table><br />~;

	$yytitle = "$sstxt{'1'}";
	&template;
	exit;
}

sub Split2 {
	if (!$iammod && !$iamadmin && !$iamgmod) { &fatal_error("$sstxt{'2'}"); }
	$oldthreadid = $INFO{'thread'};
	$postid      = $FORM{'postid'} || $INFO{'postid'};

	# Read existing thread.
	fopen(FILE, "$datadir/$oldthreadid.txt");
	@messages = <FILE>;
	fclose(FILE);

	$remaining = $#messages - scalar($postid);
	($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $dummy) = split(/[\|]/, $messages[$postid], 13);

	# Find a valid random ID for new thread.
	$newthreadid = $tmpdate + 1;
	while (-e "$datadir/$newthreadid.txt") { $newthreadid++; }

	$tmpmessage = qq~$sstxt{'5'} \[link=$scripturl?num=$newthreadid\]$sstxt{'6'}\[/link\]~;

	# Update existing thread.
	fopen(FILE, "+>$datadir/$oldthreadid.txt");
	for ($i = 0; $i < $postid; $i++) {
		print FILE $messages[$i];
	}
	print FILE qq~$tmpsub|${$uid.$username}{'realname'}|${$uid.$username}{'email'}|$tmpdate|$username|exclamation|0|$user_ip|$tmpmessage||\n~;
	fclose(FILE);

	# Update old ctb.
	&MessageTotals("load", $oldthreadid);
	%$newthreadid = %$oldthreadid;
	${$oldthreadid}{'replies'}    = $postid;
	${$oldthreadid}{'lastposter'} = $username;
	&MessageTotals("update", $oldthreadid);

	# Increment post count and lastpost date for the member.
	# Check whether zeropost board
	if (!${$uid.$currentboard}{'zero'}) {
		${$uid.$username}{'postcount'}++;
		&UserAccount($username, "update", "lastpost");
	} else {
		&UserAccount($username, "update", "lastpost");
	}

	# Save new thread.
	fopen(FILE, ">$datadir/$newthreadid.txt");
	for ($i = $postid; $i <= $#messages; $i++) {
		print FILE $messages[$i];
	}
	fclose(FILE);

	# Save new ctb.
	${$newthreadid}{'replies'} = $remaining;
	&MessageTotals("update", $newthreadid);

	# Update message index.
	fopen(BOARD, "+<$boardsdir/$currentboard.txt", 1);
	seek BOARD, 0, 0;
	my @buffer = <BOARD>;
	truncate BOARD, 0;
	seek BOARD, 0, 0;

	for ($a = 0; $a < @buffer; $a++) {
		if ($buffer[$a] =~ m~\A$oldthreadid\|~) {
			$OldThreadLine = $buffer[$a];
			splice(@buffer, $a, 1);
			last;
		}
	}
	chomp $OldThreadLine;
	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/, $OldThreadLine);
	$OldThreadLine = qq~$mnum|$msub|$mname|$memail|$tmpdate|$postid|$musername|$micon|$mstate\n~;
	$NewThreadLine = qq~$newthreadid|$tmpsub|$tmpname|$tmpemail|$mdate|$remaining|$tmpusername|$tmpicon|$mstate\n~;

	$oldinserted = 0;
	$newinserted = 0;
	for ($a = 0; $a < @buffer; $a++) {
		@boardlinedatas = split(/\|/, $buffer[$a]);
		if (!$newinserted && $boardlinedatas[4] < $mdate) {
			print BOARD $NewThreadLine;
			$newinserted = 1;
		}
		if (!$oldinserted && $boardlinedatas[4] < $tmpdate) {
			print BOARD $OldThreadLine;
			$oldinserted = 1;
		}
		print BOARD $buffer[$a];
	}
	if (!$newinserted) {
		print BOARD $NewThreadLine;
	}
	if (!$oldinserted) {
		print BOARD $OldThreadLine;
	}
	fclose(BOARD);

	# update board totals
	&BoardTotals("load", $currentboard);
	${$uid.$currentboard}{'threadcount'}++;
	${$uid.$currentboard}{'messagecount'}++;
	if (${$uid.$currentboard}{'lastpostid'} == $oldthreadid) { ${$uid.$currentboard}{'lastpostid'} = $newthreadid; }
	${$uid.$currentboard}{'lastreply'} = $remaining;
	&BoardTotals("update", $currentboard);
	&BoardSetLastInfo($toboard);

	# now fix all attachment board info
	@attachfiles = ();
	for ($a = $postid; $a < @messages; $a++) {
		@message = split(/\|/, $messages[$a]);
		if ($message[12] ne "") { push(@attachfiles, $message[12]); }
	}
	if (@attachfiles) {
		fopen(AMP, "+<$vardir/attachments.txt", 1) || &fatal_error("$txt{'23'} $vardir/attachments.txt", 1);
		seek AMP, 0, 0;
		my @buffer = <AMP>;
		truncate AMP, 0;
		for ($a = 0; $a < @buffer; $a++) {
			if ($buffer[$a] =~ m~\A$oldthreadid\|~) {
				my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/, $row);
				for ($af = 0; $af < @attachfiles; $af++) {
					if ($attachfiles[$af] eq $amfn) {
						$buffer[$a] = qq~$newthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
					}
				}
			}
		}
		seek AMP, 0, 0;
		print AMP @buffer;
		fclose(AMP);
	}

	$yySetLocation = qq~$scripturl?num=$newthreadid~;
	&redirectexit;
}

sub Splice {
	if (!$iammod && !$iamadmin && !$iamgmod) { &fatal_error("$sstxt{'102'}"); }
	$curthread = $INFO{'thread'};
	&LoadCensorList;

	$threadlist = "";
	fopen(FILE, "$boardsdir/$currentboard.txt");
	@oldthreads = <FILE>;
	fclose(FILE);
	foreach $thread_data (@oldthreads) {
		chomp $thread_data;
		($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mattach) = split(/\|/, $thread_data);
		$msub = &Censor($msub);
		if (length($msub) > 25) { $msub = substr($msub, 0, 25) . qq~ ...~; }
		chomp $msub;
		if ($mnum ne $curthread) { $threadlist .= qq~<option value="$mnum">$msub</option>\n~; }
	}

	$yymain .= qq~
<table border="0" width="80%" cellspacing="0" cellpadding="0" class="bordercolor" align="center">
  <tr>
    <td>
      <table cellpadding="4" cellspacing="1" border="0" width="100%">
        <tr>
          <td class="titlebg"><img src="$imagesdir/admin_splice.gif" align="absmiddle" /> <font size="2" class="text1"><b>$sstxt{'101'}</b></font></td>
        </tr><tr>
          <td class="windowbg" align="center"><font size="2">
            <script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
            <form action="$scripturl?board=$currentboard;action=splice2;thread=$INFO{'thread'}" method="POST" name="split" onSubmit="return submitproc()"><br />
            <b>$sstxt{'103'}:</b> <select name="newthreadid">
		$threadlist
            </select>
            <input type="submit" value="$sstxt{'101'}" />
            </form>
          </font></td>
        </tr><tr>
          <td class="windowbg"><font size="1">$sstxt{'104'}</font></td>
        </tr>
      </table>
    </td>
  </tr>
</table><br />~;

	$yytitle = "$sstxt{'101'}";
	&template;
	exit;
}

sub Splice2 {
	if (!$iammod && !$iamadmin && !$iamgmod) { &fatal_error("$sstxt{'102'}"); }
	$oldthreadid = $INFO{'thread'};
	$newthreadid = $FORM{'newthreadid'};

	# Read existing threads.
	fopen(FILE, "$datadir/$oldthreadid.txt");
	@old_messages = <FILE>;
	fclose(FILE);
	&MessageTotals("load", $oldthreadid);

	fopen(FILE, "$datadir/$newthreadid.txt");
	@new_messages = <FILE>;
	fclose(FILE);
	&MessageTotals("load", $newthreadid);
	${$newthreadid}{'lastposter'} = ${$oldthreadid}{'lastposter'};

	# Update old thread.
	($tmpsub, @dummy) = split(/\|/, $old_messages[0]);
	($dummy, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $dummy) = split(/\|/, $old_messages[$#old_messages]);

	my $linkcount = @new_messages;
	$tmpmessage = qq~$sstxt{'105'} \[link=$scripturl?num=$newthreadid/$linkcount\#$linkcount\]$sstxt{'106'}\[/link\] $sstxt{'107'} ${$uid.$username}{'realname'}.~;
	fopen(FILE, "+>$datadir/$oldthreadid.txt");
	print FILE qq~$tmpsub|${$uid.$username}{'realname'}|${$uid.$username}{'email'}|$tmpdate|$username|exclamation|0|$user_ip|$tmpmessage||\n~;
	fclose(FILE);

	${$oldthreadid}{'replies'}    = 0;
	${$oldthreadid}{'lastposter'} = $username;
	&MessageTotals("update", $oldthreadid);

	# Increment post count and lastpost date for the member.
	# Check whether zeropost board
	if (!${$uid.$currentboard}{'zero'}) {
		${$uid.$username}{'postcount'}++;
		&UserAccount($username, "update", "lastpost");
	} else {
		&UserAccount($username, "update", "lastpost");
	}

	# Update new thread.
	fopen(FILE, "+>$datadir/$newthreadid.txt");
	print FILE @new_messages;
	print FILE @old_messages;
	fclose(FILE);

	${$newthreadid}{'replies'} = @new_messages + @old_messages - 1;
	&MessageTotals("update", $newthreadid);

	# Update message index.
	fopen(BOARD, "+<$boardsdir/$currentboard.txt", 1);
	seek BOARD, 0, 0;
	my @buffer = <BOARD>;
	truncate BOARD, 0;
	seek BOARD, 0, 0;

	my $found = 0;
	for ($a = 0; $a < @buffer; $a++) {
		if ($buffer[$a] =~ m~\A$oldthreadid\|~) {
			$OldThreadLine = $buffer[$a];

			chomp $OldThreadLine;
			($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/, $OldThreadLine);
			$msub = qq~$sstxt{'108'}: $msub~;
			if ($mstate !~ /l/i) { $mstate .= "l"; }
			$OldThreadLine = qq~$mnum|$msub|$mname|$memail|$mdate|0|$musername|$micon|$mstate\n~;
			$buffer[$a] = $OldThreadLine;
		}
		if ($buffer[$a] =~ m~\A$newthreadid\|~) {
			$NewThreadLine = $buffer[$a];

			chomp $NewThreadLine;
			($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/, $NewThreadLine);
			$NewThreadLine = qq~$mnum|$msub|$mname|$memail|$tmpdate|${$newthreadid}{'replies'}|$musername|$micon|$mstate\n~;
			$buffer[$a] = $NewThreadLine

		}
	}

	print BOARD @buffer;
	fclose(BOARD);

	# update board totals
	&BoardTotals("load", $currentboard);
	${$uid.$currentboard}{'messagecount'}++;
	&BoardTotals("update", $currentboard);
	&BoardSetLastInfo($currentboard);

	# now fix all attachment board info
	@attachfiles = ();
	for ($a = 0; $a < @old_messages; $a++) {
		@messages = split(/\|/, @old_messages[$a]);
		if ($message[12] ne "") { push(@attachfiles, $message[12]); }
	}
	if (@attachfiles) {
		fopen(AMP, "+<$vardir/attachments.txt", 1) || &fatal_error("$txt{'23'} $vardir/attachments.txt", 1);
		seek AMP, 0, 0;
		my @buffer = <AMP>;
		truncate AMP, 0;
		for ($a = 0; $a < @buffer; $a++) {
			if ($buffer[$a] =~ m~\A$oldthreadid\|~) {
				my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/, $row);
				for ($af = 0; $af < @attachfiles; $af++) {
					if ($attachfiles[$af] eq $amfn) {
						$buffer[$a] = qq~$newthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
					}
				}
			}
		}
		seek AMP, 0, 0;
		print AMP @buffer;
		fclose(AMP);
	}

	$yySetLocation = qq~$scripturl?num=$newthreadid~;
	&redirectexit;
}

sub Split_Splice_Adv {
	if (!$iammod && !$iamadmin && !$iamgmod) { &fatal_error("$sstxt{'2'}"); }
	&Split_Splice_Adv2 if $FORM{'ssa_submit'};
	
	$curcat = $INFO{'cat'};
	$curboard = $INFO{'board'};
	$curthread = $INFO{'thread'};
	$newcat = $FORM{'newcat'} || $INFO{'cat'};
	$newboard = $FORM{'newboard'} || $INFO{'board'};
	$newthread = $FORM{'newthread'} || "new";
	&LoadCensorList;
	LoadLanguage("Split_Splice_Adv");
	
	# Get posts of current thread	
	fopen(FILE, "$datadir/$curthread.txt");
	@messages = <FILE>;
	fclose(FILE);

	$postlist = ($FORM{'oldposts'} =~ /\ball\b/) ? qq~<option value="all" selected>$split_splice_adv{'26'}</option>\n~ : qq~<option value="all">$split_splice_adv{'26'}</option>\n~;
	for ($counter = 0; $counter <= $#messages; $counter++) {
	 	$sef = ($counter != 0) ? qq~Reply $counter~ : qq~$split_splice_adv{'27'}~;
		chomp $messages[$counter];
		($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb) = split(/[\|]/, $messages[$counter]);
		$postmessage = &Censor($postmessage);
		if (length($postmessage) > 50) { $postmessage = substr($postmessage, 0, 50) . qq~ ...~; }
		my $sel = "selected" if ($FORM{'oldposts'} =~ /\b$counter\b/);
		$postlist .= qq~<option value="$counter" $sel>$sef: $postmessage</option>\n~;
	}
	
	# List of options of what, if anything, to leave in place of the posts moved
	@leaveopts = ($split_splice_adv{'11'}, $split_splice_adv{'12'}, $split_splice_adv{'13'});
	for ($counter = 0; $counter <= $#leaveopts; $counter++) {
		my $sel = "selected" if $FORM{'leave'} eq $counter;
		$leavelist .= qq~<option value="$counter" $sel>$leaveopts[$counter]</option>\n~;
	}

	# Get categories and make the current one the default selection
	$catlist = qq~<option value="cats" >$split_splice_adv{'28'}</option>\n~;
	foreach (@categoryorder) {
		my ($catname, $catperms) = split(/[\|]/, $catinfo{$_});
		$catname = &Censor($catname);
		my $access = &CatAccess($catperms);
		if (!$access) { next; }		
		my $sel = "selected" if $newcat eq $_;
		$catlist .= qq~<option value="$_" $sel>$catname</option>\n~;
	}
	
	# Get boards and make the current one the default selection
	@boards = split (/\,/, $cat{$newcat});
	$boardlist = qq~<option value="boards" >$split_splice_adv{'29'}</option>\n~;
	foreach (@boards) {
		my ($boardname, $boardperms) = split(/[\|]/, $board{$_});
		$boardname = &Censor($boardname);
		my $access = &AccessCheck($_, '', $boardperms);
		if (!$iamadmin && $access ne "granted" && $boardview != 1) { next; }		
		my $sel = "selected" if $newboard eq $_;
		$boardlist .= qq~<option value="$_" $sel>$boardname</option>\n~;
	}
	
	# Get threads and make the current one the default selection
	if ($cat{$newcat} =~ /\b$newboard\b/) {		
		fopen(FILE, "$boardsdir/$newboard.txt");
		@threads = <FILE>;
		fclose(FILE);
	
		$threadlist = qq~<option value="new">$split_splice_adv{'30'}</option>\n~;
		foreach (@threads) {
			my ($threadid, $threadname) = split(/[\|]/, $_);
			if ($curthread eq $threadid) {next;}
			$threadids .= "$threadid,";
			$threadname = &Censor($threadname);
			$threadname =~ s/\A\[m\]/$maintxt{'758'}/;
			my $sel = "selected" if $newthread eq $threadid;
			$threadlist .= qq~<option value="$threadid" $sel>$threadname</option>\n~;
		}
	}
	
	# Get new thread posts to select splice site
	if ($FORM{'newthread'} ne "new" && $cat{$newcat} =~ /\b$newboard\b/){
		fopen(FILE, "$datadir/$newthread.txt");
		@position = <FILE>;
		fclose(FILE);
		
		$positionlist = qq~<option value="end">$split_splice_adv{'31'}</option>\n~;
		$positionlist .= qq~<option value="begin">$split_splice_adv{'32'}</option>\n~;
		for ($counter = 0; $counter <= $#position; $counter++) {
			$sef = ($counter != 0) ? qq~$split_splice_adv{'33'} $counter~ : qq~$split_splice_adv{'27'}~;
			chomp $position[$counter];
			($msub, $mname, $memail, $mdate, $musername, $micon, $mattach, $mip, $postmessage, $ns, $mlm, $mlmb) = split(/[\|]/, $position[$counter]);
			$postmessage = &Censor($postmessage);
			if (length($postmessage) > 50) { $postmessage = substr($postmessage, 0, 50) . qq~ ...~; }
			$positionlist .= qq~<option value="$counter">$sef: $postmessage</option>\n~;
		}
	}
		
	$yymain .= qq~	
<table border="0" width="80%" cellspacing="0" cellpadding="0" class="bordercolor" align="center">
  <tr>
    <td>
      <script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
      <form action="$scripturl?cat=$curcat;board=$currentboard;action=split_splice_adv;thread=$INFO{'thread'}" method="POST" name="split_splice_adv" onSubmit="return submitproc()">
      <table cellpadding="4" cellspacing="1" border="0" width="100%">
        <tr>
          <td class="titlebg" colspan="2"><img src="$modimgurl/Split_Splice_Adv/split_splice_adv.$imgext" /> <font size="2" class="text1"><b>$split_splice_adv{'1'}</b></font></td>
        </tr><tr>
          <td class="catbg" colspan="2"><font size="2"><b>$split_splice_adv{'2'}</b></td>
        </tr><tr>        
          <td class="windowbg" width="20%"><font size="2"><b>$split_splice_adv{'3'}</b><br /><font size="1">$split_splice_adv{'14'}</font></td>
          <td class="windowbg"><select name="oldposts" multiple size="5" style="width:100%">$postlist</select></font></td>
        </tr><tr>
          <td class="windowbg"><font size="2"><b>$split_splice_adv{'4'}</b><br /><font size="1">$split_splice_adv{'15'}</font></td>
          <td class="windowbg"><select name="leave">$leavelist</select></font></td>
        </tr><tr>        
          <td class="catbg" colspan="2"><font size="2"><b>$split_splice_adv{'5'}</b></td>
        </tr><tr>
          <td class="windowbg"><font size="2"><b>$split_splice_adv{'6'}</b><br /><font size="1">$split_splice_adv{'16'}</font></td>
          <td class="windowbg"><select name="newcat" onChange="document.split_splice_adv.submit();">$catlist</select></font></td>
        </tr><tr>           
          <td class="windowbg"><font size="2"><b>$split_splice_adv{'7'}</b><br /><font size="1">$split_splice_adv{'17'}</font></td>
          <td class="windowbg"><select name="newboard" onChange="document.split_splice_adv.submit();">$boardlist</select></font></td>
        </tr><tr>   
          <td class="windowbg"><font size="2"><b>$split_splice_adv{'8'}</b><br /><font size="1">$split_splice_adv{'18'}</font></td>
          <td class="windowbg"><select name="newthread" onChange="document.split_splice_adv.submit();">$threadlist</select></font></td>
        </tr>~;
       if ($newthread eq "new" || !$threadlist || ($threadids !~ /\b$newthread\b/)){
        	$yymain .= qq~
       	<tr>
          <td class="windowbg"><font size="2"><b>$split_splice_adv{'9'}</b></font><br /><font size="1">$split_splice_adv{'20'}</font></td>
          <td class="windowbg"><input type="text" name="newthread_subject" style="width:100%" /></td>
        </tr>~;}
       else {	$yymain .= qq~	
               <tr>
          <td class="windowbg"><font size="2"><b>$split_splice_adv{'10'}</b><br /><font size="1">$split_splice_adv{'19'}</font></td>
          <td class="windowbg"><select name="position">$positionlist</select></font></td>
        </tr>~;}       	
        $yymain .= qq~	
        <tr>           
          <td class="windowbg" align="center" colspan="2"><input type="submit" name="ssa_submit" value="$split_splice_adv{'24'}" />&nbsp;<input type="Reset" value="$split_splice_adv{'25'}" /></td>
        </tr>
      </table>
      </form>
    </td>
  </tr>
</table><br />~;

	$yytitle = "$sstxt{'101'}";
	&template;
	exit;
}

sub Split_Splice_Adv2 {
	if (!$iammod && !$iamadmin && !$iamgmod) { &fatal_error("$sstxt{'102'}"); }
	LoadLanguage("Split_Splice_Adv");
	
	$curcat = $INFO{'cat'};
	$curboard = $INFO{'board'};
	$curthreadid = $INFO{'thread'};
	$movingposts = $FORM{'oldposts'};
	$leavemess = $FORM{'leave'};
	$newcat = $FORM{'newcat'};
	$newboard = $FORM{'newboard'};
	$newthreadid = $FORM{'newthread'};
	$newthreadsub = $FORM{'newthread_subject'};
	$newposition = $FORM{'position'};
	
	# Error messages if something is not filled out right
	fatal_error("$split_splice_adv{'22'} $split_splice_adv{'23'}") if !$movingposts;
	fatal_error("$split_splice_adv{'22'} $split_splice_adv{'6'}") if $newcat eq 'cats';
	fatal_error("$split_splice_adv{'22'} $split_splice_adv{'7'}") if $newboard eq 'boards';
	
	# Get current thread posts
	fopen(FILE, "$datadir/$curthreadid.txt") || fatal_error("539");
	@curthread = <FILE>;
	fclose(FILE);
	&MessageTotals("load", $curthreadid);
	
	# Store post numbers to be moved in array
	@postnum = split (/\, /, $movingposts);
	if ($postnum[0] eq "all") {@postnum = (0 .. $#curthread);}
	
	# Move selected posts to a brand new thread
	if ($newthreadid eq "new") {
		($tmpsub, $tmpname, $tmpemail, $tmpdate) = split(/[\|]/, $curthread[$postnum[0]]);
		
		# Find a valid random ID for new thread.
		$newthreadid = $tmpdate + 1;
		while (-e "$datadir/$newthreadid.txt") { $newthreadid++; }
		
		# Create new thread
		fopen(FILE, ">$datadir/$newthreadid.txt") || fatal_error("557");
			foreach (@postnum) {
				if ($newthreadsub) {
				 	my ($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $dummy) = split(/[\|]/, $curthread[$_]);
					 $tmpsub = $curthread[$_] eq $curthread[$postnum[0]] ? $newthreadsub : qq~$split_splice_adv{'21'} $newthreadsub~;
					$flynn = qq~$tmpsub|$tmpname|$tmpemail|$tmpdate|$tmpusername|$tmpicon|$tmpattach|$tmpip|$tmpmessage|$tmpns|$tmplm|$tmplmb|$dummy~;
				}
				else {$flynn = $curthread[$_]}
				print FILE $flynn;
				push (@utdnewthread, $flynn);
			}
		fclose(FILE);		
	}
	
	# Place selected posts in existing thread at selected position
	else {
		# Get existing thread posts
		fopen(FILE, "$datadir/$newthreadid.txt")  || fatal_error("573");
		@newthread = <FILE>;
		fclose(FILE);
		&MessageTotals("load", $newthreadid);
		
		if ($newposition eq "end") {$newposition = $#newthread;}
		if ($newposition eq "begin") {
			foreach (@postnum){
				push (@utdnewthread, $curthread[$_]);
			}
			$linkcount = 0;
		}		
		for ($i=0; $i<=$#newthread; $i++){
			push (@utdnewthread, $newthread[$i]);
			if ($newposition == $i && $newposition ne "begin") {
				foreach (@postnum){
					push (@utdnewthread, $curthread[$_]);
				}		
				$linkcount = $i + 1;		
			}
		}
	}
	
	# Get last poster username and time to newthread .
	($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $dummy) = split(/[\|]/, $utdnewthread[$#utdnewthread]);
	$newlastposter = $tmpusername;
	$newlastposttime = $tmpdate;
	
	# Remove or copy selected posts from current thread
	if (($postnum[0] eq "all" || $#postnum == $#curthread) && $leavemess != 1){
		my ($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $dummy) = split(/[\|]/, $curthread[0]);
		$tmpmessage = qq~$sstxt{'105'} \[link=$scripturl?num=$newthreadid/$linkcount\#$linkcount\]$sstxt{'106'}\[/link\] $sstxt{'107'} ${$uid.$username}{'realname'}.~;
		$utdcurthread[0] = qq~$tmpsub|${$uid.$username}{'realname'}|${$uid.$username}{'email'}|$tmpdate|$username|exclamation|0|$user_ip|$tmpmessage||\n~;
	}
	elsif ($leavemess != 1) { 
		for ($i=0; $i<=$#curthread; $i++){
			if ($movingposts =~ /\b$i\b/){
				if ($i == $postnum[$#postnum] && $leavemess == 0){
					my ($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $dummy) = split(/[\|]/, $curthread[$i]);
					$tmpmessage = qq~$sstxt{'5'} \[link=$scripturl?num=$newthreadid/$linkcount\#$linkcount\]$sstxt{'6'}\[/link\]~;
					$curthread[$i] = qq~$tmpsub|${$uid.$username}{'realname'}|${$uid.$username}{'email'}|$tmpdate|$username|exclamation|0|$user_ip|$tmpmessage||\n~;
				}
				else {next;}
			}
			push (@utdcurthread, $curthread[$i]);
		}			
	}
	else {@utdcurthread = @curthread;}
	
	($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $dummy) = split(/[\|]/, $utdcurthread[$#utdcurthread]);
	if ((($postnum[0] eq "all" || $#postnum == $#curthread) && $leavemess != 1) || $leavemess == 0) {
		# Increment post count and lastpost date for the member.
		# Check whether zeropost board
		if (!${$uid.$currentboard}{'zero'}) {
			${$uid.$username}{'postcount'}++;
			&UserAccount($username, "update", "lastpost");
		} else {
			&UserAccount($username, "update", "lastpost");
		}
	}
	$curlastposter = $tmpusername;
	$curlastposttime = $tmpdate;
	
	# Update current thread
	fopen(FILE, ">$datadir/$curthreadid.txt")  || fatal_error("638");
	print FILE @utdcurthread;
	fclose(FILE);
	
	# Update new thread
	if ($FORM{'newthread'} ne 'new') {	
		fopen(FILE, ">$datadir/$newthreadid.txt")  || fatal_error("644");
		print FILE @utdnewthread;
		fclose(FILE);
	}
	
	# Update new ctb.
	&MessageTotals("load", $newthreadid);
	${$newthreadid}{'replies'}    = $#utdnewthread;
	${$newthreadid}{'lastposter'} = $newlastposter;
	${$newthreadid}{'lastpostdate'} = $newlastposttime;
	if ($FORM{'newthread'} eq 'new') {
		${$newthreadid}{'board'}    = $newboard;
		${$newthreadid}{'views'}    = 0;
	}
	&MessageTotals("update", $newthreadid);
	
	# Update current ctb.
	&MessageTotals("load", $curthreadid);
	${$curthreadid}{'replies'}    = $#utdcurthread;
	${$curthreadid}{'lastposter'} = $curlastposter;
	${$curthreadid}{'lastpostdate'} = $curlastposttime;
	&MessageTotals("update", $curthreadid);
	
	# Update current message index.
	fopen(BOARD, "+<$boardsdir/$curboard.txt", 1)  || fatal_error("668");
	my @curmessindex = <BOARD>;
	fclose(BOARD);	
	
	for ($a = 0; $a < @curmessindex; $a++) {
		if ($curmessindex[$a] =~ m~\A$curthreadid\|~) {
			$OldThreadLine = $curmessindex[$a];
			chomp $OldThreadLine;
			($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/, $OldThreadLine);
			if ($postnum[0] eq "all" || ($#postnum == $#curthread && $leavemess != 1)) {
				$msub = qq~$sstxt{'108'}: $msub~;
				$mreplies = 0;
				if ($mstate !~ /l/i) { $mstate .= "l"; }
			}
			else{$mreplies = ${$curthreadid}{'replies'};}
			$OldThreadLine = qq~$mnum|$msub|$mname|$memail|${$curthreadid}{'lastpostdate'}|$mreplies|$musername|$micon|$mstate\n~;
			$curmessindex[$a] = $OldThreadLine;			
		}
		if ($curmessindex[$a] =~ m~\A$newthreadid\|~) {
			$NewThreadLine = $curmessindex[$a];
			chomp $NewThreadLine;
			($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/, $NewThreadLine);
			if ($FORM{'position'} eq 'begin') {
				($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $dummy) = split(/[\|]/, $utdnewthread[0]);
				$msub = $tmpsub;
				$musername = $tmpusername;
				&LoadUser($musername);
				$mname = ${$uid.$musername}{'realname'};
				$memail = ${$uid.$musername}{'email'};
				$musername = $tmpusername;
				$micon = $tmpicon;
			}
			$NewThreadLine = qq~$mnum|$msub|$mname|$memail|${$newthreadid}{'lastpostdate'}|${$newthreadid}{'replies'}|$musername|$micon|$mstate\n~;
			$curmessindex[$a] = $NewThreadLine			
		}
	}
	if ($curboard eq $newboard && $FORM{'newthread'} eq 'new') {
		($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $dummy) = split(/[\|]/, $utdnewthread[0]);
		$mnum = $newthreadid;
		$msub = $tmpsub;
		$musername = $tmpusername;
		&LoadUser($musername);
		$mname = ${$uid.$musername}{'realname'};
		$memail = ${$uid.$musername}{'email'};
		$micon = $tmpicon;
		$mstate = 0;
		$NewThreadLine = qq~$mnum|$msub|$mname|$memail|${$newthreadid}{'lastpostdate'}|${$newthreadid}{'replies'}|$musername|$micon|$mstate\n~;
		unshift (@curmessindex, $NewThreadLine);
	}
	fopen(BOARD, ">$boardsdir/$curboard.txt", 1)  || fatal_error("716");
	print BOARD @curmessindex;
	fclose(BOARD);
	
	# Update new message index if needed.
	if ($curboard ne $newboard) {
		fopen(BOARD, "+<$boardsdir/$newboard.txt", 1) || fatal_error("722");
		my @newmessindex = <BOARD>;
		fclose(BOARD);		
		
		for ($a = 0; $a < @newmessindex; $a++) {
			if ($newmessindex[$a] =~ m~\A$newthreadid\|~) {
				$NewThreadLine = $newmessindex[$a];
				chomp $NewThreadLine;
				($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split(/\|/, $NewThreadLine);
				if ($FORM{'position'} eq 'begin') {
					($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $dummy) = split(/[\|]/, $utdnewthread[0]);
					$msub = $tmpsub;
					&LoadUser($musername);
					$mname = ${$uid.$musername}{'realname'};
					$memail = ${$uid.$musername}{'email'};
					$musername = $tmpusername;
					$micon = $tmpicon;
				}
				$NewThreadLine = qq~$mnum|$msub|$mname|$memail|${$newthreadid}{'lastpostdate'}|${$newthreadid}{'replies'}|$musername|$micon|$mstate\n~;
				$newmessindex[$a] = $NewThreadLine			
			}
		}
		if ($FORM{'newthread'} eq 'new') {
			($tmpsub, $tmpname, $tmpemail, $tmpdate, $tmpusername, $tmpicon, $tmpattach, $tmpip, $tmpmessage, $tmpns, $tmplm, $tmplmb, $dummy) = split(/[\|]/, $utdnewthread[0]);
			$mnum = $newthreadid;
			$msub = $tmpsub;
			&LoadUser($musername);
			$mname = ${$uid.$musername}{'realname'};
			$memail = ${$uid.$musername}{'email'};
			$musername = $tmpusername;
			$micon = $tmpicon;
			$NewThreadLine = qq~$mnum|$msub|$mname|$memail|${$newthreadid}{'lastpostdate'}|${$newthreadid}{'replies'}|$musername|$micon|$mstate\n~;
			unshift (@newmessindex, $NewThreadLine);
		}
		
		fopen(BOARD, ">$boardsdir/$newboard.txt", 1) || fatal_error("757");
		print BOARD @newmessindex;
		fclose(BOARD);
	}

	# update current board totals.
	&BoardTotals("load", $curboard);
	if ($FORM{'newthread'} eq 'new' && $curboard eq $newboard) {${$uid.$curboard}{'threadcount'}++;}
	if (${$uid.$curboard}{'lastpostid'} == $curthreadid) { ${$uid.$curboard}{'lastpostid'} = $newthreadid; }
	if ($leavemess == 0) {
		if($curboard ne $newboard) {${$uid.$curboard}{'messagecount'} = ${$uid.$curboard}{'messagecount'} - $#postnum;}
		else {${$uid.$curboard}{'messagecount'}++;}
	}
	elsif ($leavemess == 1) {
		if($curboard eq $newboard) {${$uid.$curboard}{'messagecount'} = ${$uid.$curboard}{'messagecount'} + $#postnum + 1;}		
	}
	elsif ($leavemess == 2) {
		if($curboard ne $newboard) {${$uid.$curboard}{'messagecount'} = ${$uid.$curboard}{'messagecount'} - $#postnum - 1;}			
	}	
	
	&BoardTotals("update", $curboard);
	&BoardSetLastInfo($curboard);
	
	# update new board totals if needed.
	if ($curboard ne $newboard) {
		&BoardTotals("load", $newboard);
		if ($FORM{'newthread'} eq 'new') {${$uid.$newboard}{'threadcount'}++;}		
		${$uid.$newboard}{'messagecount'} = ${$uid.$newboard}{'messagecount'} + $#postnum + 1;		
		&BoardTotals("update", $newboard);
		&BoardSetLastInfo($newboard);
	}	
	
	# now fix all attachment board info
	@attachfiles = ();
	foreach (@postnum){
		push (@old_messages, $curthread[$_]);
	}	
	for ($a = 0; $a < @old_messages; $a++) {
		@messages = split(/\|/, @old_messages[$a]);
		if ($message[12] ne "") { push(@attachfiles, $message[12]); }
	}
	if (@attachfiles) {
		fopen(AMP, "+<$vardir/attachments.txt", 1) || &fatal_error("$txt{'23'} $vardir/attachments.txt", 1);
		seek AMP, 0, 0;
		my @buffer = <AMP>;
		truncate AMP, 0;
		for ($a = 0; $a < @buffer; $a++) {
			if ($buffer[$a] =~ m~\A$curthreadid\|~) {
				my ($amthreadid, $amreplies, $amthreadsub, $amposter, $amcurrentboard, $amkb, $amdate, $amfn) = split(/\|/, $row);
				for ($af = 0; $af < @attachfiles; $af++) {
					if ($attachfiles[$af] eq $amfn) {
						$buffer[$a] = qq~$newthreadid|$amreplies|$amthreadsub|$amposter|$amcurrentboard|$amkb|$amdate|$amfn\n~;
					}
				}
			}
		}
		seek AMP, 0, 0;
		print AMP @buffer;
		fclose(AMP);
	}

	#fatal_error("made it here without error");
	$yySetLocation = qq~$scripturl?num=$newthreadid~;
	&redirectexit;
}

1;
